header {

package com.evelopers.unimod.analysis;

}

class DNFTreePrinter extends TreeParser;
options {
    buildAST = false;    // uses CommonAST by default
    importVocab = Expr;
	defaultErrorHandler = false;
}

{
    public static String toString(AST ast) throws RecognitionException {
        DNFTreePrinter printer = new DNFTreePrinter();
        return printer.p(ast);
    }

    public static void print(AST ast) throws RecognitionException {
        System.out.println(toString(ast));
    }
}

p returns [String str]
    :   OR
        {
            StringBuffer buffer = new StringBuffer();
            for (AST child = p_AST_in.getFirstChild(); child != null; child = child.getNextSibling()) {
                buffer.append(" || ").append(p(child));
            }
            str = buffer.toString();
        }
    |   AND
        {
            AST child = p_AST_in.getFirstChild();
            StringBuffer buffer = new StringBuffer(" (");
            buffer.append(p(child));
            for (child = child.getNextSibling(); child != null; child = child.getNextSibling()) {
                buffer.append(" && ").append(p(child));
            }
            buffer.append(") ");
            str = buffer.toString();
        }
    |   NOT
        {
            str = "!"+p(p_AST_in.getFirstChild());
        }
    |   (EQUAL | NEQUAL | GE | GT | LE | LT)
        {
            str = p(p_AST_in.getFirstChild())+" "+p_AST_in.getText()+" "+p(p_AST_in.getFirstChild().getNextSibling());
        }
    |   (TRUE | FALSE | IDENT | CONST_NUM)
        {
            str = p_AST_in.getText();
        }
    ;
